// AIMaxR.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <list>
#include <../player.h>
#include <../loaddata.h>

#include <../network.h>
#include <../menuevents.h>
#include <../clientevents.h>
#include <../client.h>
#include <../events.h>
#include <../netmessage.h>
#include <../mapdownload.h>
#include <../serverevents.h>
#include <../attackJobs.h>

enum gameStates {init, chooseStart, ChoosePoint, running};

gameStates gameState = init;


sMenuPlayer playerdata; // this player
std::list<sMenuPlayer*> players;
cList<cPlayer*> playerscList;
cPlayer* thePlayer;
sSettings theSettings;
cMap map;
int clan = 2;
cList<sLandingUnit> landingparty;
sClientLandData landingdata;

// to avoid cycling if the map is invalid!
std::string lastRequestedMap;
cMapReceiver *mapreceiver = NULL; // buffer to download maps

class InitEventHandler : public cEventHandling {
public:
	void HandleEvents1();
};


void HandleNetMsg(cNetMessage * message) {
	switch ( message->iType )
	{
	case GAME_EV_REFRESH_RESEARCH_COUNT:
		break;
	case GAME_EV_MAKE_TURNEND:
		break;
	case GAME_EV_FINISHED_TURN:
		break;
	case GAME_EV_ATTACKJOB_LOCK_TARGET:
		cClientAttackJob::lockTarget( message );
		break;
	case GAME_EV_ATTACKJOB_FIRE:
	{
		// we are under attach!!
		cClientAttackJob* job = new cClientAttackJob( message );
		Client->attackJobs.Add( job );
		break;
	}
	default:
		std::cerr << "Ignoring net message: " + message->iType << std::endl;  // ?? doesn't work right ..
		Log.write((std::string("Ignoring net message: ") + message->getTypeAsString()).c_str());
	}
	cClientAttackJob::handleAttackJobs();
	sendWantToEndTurn();
}


void InitEventHandler::HandleEvents1() {
		cNetMessage *message;
		while ( eventQueue.size() > 0 )
		{
			message = eventQueue.read();
			switch (message->getClass())
			{
			case NET_MSG_CLIENT:
				HandleNetMsg(message); 				
			break;
			case NET_MSG_MENU:
				switch ( message->iType )
				{
					case MU_MSG_ALL_LANDED: {
						// build the client 
						playerscList.Add(thePlayer);
						Client = new cClient( &map, &playerscList );
						Client->initPlayer ( thePlayer );
						break;
					}
					case MU_MSG_GO: {
						// server says go ..
						sendClan (clan,playerdata.nr, false);

						sLandingUnit t;
						t.cargo = 40;
						t.unitID = sID();
						t.unitID.generate("0 24"); //small const
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						t.cargo = 50;
						t.unitID.generate("0 19"); // big const
						landingparty.Add(t);
						landingparty.Add(t);
						t.unitID.generate("0 26"); // scanner
						landingparty.Add(t);
						landingparty.Add(t);
						t.unitID.generate("0 31"); // surveyor
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						t.unitID.generate("0 32"); // tank
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);
						landingparty.Add(t);



						sendLandingUnits ( &landingparty,playerdata.nr, false );
						sendUnitUpgrades (thePlayer, false );
						// landing
						landingdata.iLandX = 3;
						landingdata.iLandY = 3;						
						sendLandingCoords (landingdata, playerdata.nr, false );
						break;
					}
				//
					case GAME_EV_REQ_RECON_IDENT: {
						cNetMessage *message = new cNetMessage ( GAME_EV_IDENTIFICATION );
						message->pushInt16 ( -1 );
						message->pushString ( "Razvan" );
						cMenu::sendMessage( message );
						break;
					}

					case MU_MSG_RESELECT_LANDING: 
						sendLandingCoords (landingdata, playerdata.nr, false );
						break;
					case MU_MSG_CHAT:
					{
						bool translationText = message->popBool();
						std::string chatText = message->popString();
						if ( translationText ) {
							chatText = lngPack.i18n ( chatText );
						}
						std::cout << "Chat text : " << chatText << std::endl;
						std::cout << "NLP AI will be available in version 2.0. this means, message ignored!" << std::endl;
						break;
					}
					case MU_MSG_START_MAP_DOWNLOAD: 
						{
								int mapSize = message->popInt32 ();
								std::string mapName = message->popString ();
								if (mapreceiver != 0) delete mapreceiver;
								mapreceiver = new cMapReceiver (mapName, mapSize);
						}
						break;
					case MU_MSG_REQ_IDENTIFIKATION: {
						std::string ver = message->popString();
						std::cout << "Server version ... " << ver << std::endl;

						playerdata.color = cl_orange;
						playerdata.name = "Razvan";
						playerdata.ready = true;
						playerdata.nr =  message->popInt16();
						playerdata.socket = 0;
						sendIdentification ( &playerdata );
						thePlayer = new cPlayer (playerdata.name, OtherData.colors[playerdata.color], playerdata.nr, -1);

						break;
					}

				case GAME_EV_RECONNECT_ANSWER:
				{
					if ( message->popBool() )
					{
						playerdata.nr = message->popInt16();
						playerdata.color = message->popInt16();
						cMap *Map = new cMap;
						if ( !Map->LoadMap ( message->popString() ) ) break;

						int playerCount = message->popInt16();
						players.clear(); //Remove memory leak!!
						while ( playerCount > 1 )
						{
							std::string playername = message->popString();
							int playercolor = message->popInt16();
							int playernr = message->popInt16();
							sMenuPlayer *player = new sMenuPlayer ( playername, playercolor, true, playernr ); // assume true
							players.push_back ( player );
							playerCount--;
						}
					}
					playerdata.ready = true;
					sendIdentification ( &playerdata );
					break;
				}

					case MU_MSG_PLAYERLIST: {
						int playerCount = message->popInt16();
						int actPlayerNr = playerdata.nr;
						while ( players.size() > 0 ) {
							delete *players.begin();
							players.remove(*players.begin());
						}						
						for ( int i = 0; i < playerCount; i++ )
						{
							std::string name = message->popString();
							int color = message->popInt16();
							bool ready = message->popBool();
							int nr = message->popInt16();
							sMenuPlayer *player = new sMenuPlayer ( name, color, ready, nr );
							players.push_back ( player );
						}
						break;
					}
					case MU_MSG_FINISHED_MAP_DOWNLOAD: 
						{
							mapreceiver->finished ();
							if (!map.LoadMap (mapreceiver->getMapName ()))
								std::cerr << "Error receiving the map!";
							delete mapreceiver;
							mapreceiver = NULL;
							if (!playerdata.ready) {
								playerdata.ready = true;
								sendIdentification ( &playerdata );
							}

						}
						break;
					case MU_MSG_MAP_DOWNLOAD_DATA:
						{
							int nrBytesInMsg = message->popInt32 ();
							mapreceiver->receiveData (message, nrBytesInMsg);
							int size = mapreceiver->getMapSize ();
							int received = mapreceiver->getBytesReceived ();
							int finished = (received * 100) / size;
							std::cout << lngPack.i18n ( "Text~Multiplayer~MapDL_Percent", iToStr(finished) );
						}
						break;
					case MU_MSG_OPTINS:
					{
							if ( message->popBool() )
							{
								sSettings *settings = &theSettings;
								settings->duration = (eSettingsDuration)message->popInt16();
								settings->victoryType = (eSettingsVictoryType)message->popChar();
								settings->metal = (eSettingResourceValue)message->popChar();
								settings->oil = (eSettingResourceValue)message->popChar();
								settings->gold = (eSettingResourceValue)message->popChar();
								settings->resFrequency = (eSettingResFrequency)message->popChar();
								settings->credits = (eSettingsCredits)message->popInt16();
								settings->bridgeHead = (eSettingsBridgeHead)message->popChar();
								settings->alienTech = (eSettingsAlienTech)message->popChar();
								settings->clans = (eSettingsClans)message->popChar();
								settings->gameType = (eSettingsGameType)message->popChar();
							}

							if ( message->popBool() )
							{
								std::string mapName = message->popString();
								Sint32 mapCheckSum = message->popInt32();

								bool mapCheckSumsEqual = (MapDownload::calculateCheckSum (mapName) == mapCheckSum);
								if (!mapCheckSumsEqual || ! map.LoadMap ( mapName ) )
								{
										if ( playerdata.ready )
										{
											std::cout << lngPack.i18n( "Text~Multiplayer~No_Map_No_Ready", mapName )  << std::endl;
											playerdata.ready = false;
											sendIdentification ( &playerdata );
										}
										std::string triedLoadMap = mapName;

										std::string existingMapFilePath = MapDownload::getExistingMapFilePath (mapName);
										bool existsMap = !existingMapFilePath.empty();
										if (!mapCheckSumsEqual && existsMap)
										{
											std::cout << "You have an incompatible version of the map"  
											<<  "\""<<  mapName <<  "\" at"  << std::endl 
											<< "\"" <<  existingMapFilePath <<  "\" !" << std::endl  <<
											"Move it away or delete it, then reconnect." << std::endl;
										}
										else
										{
											if (MapDownload::isMapOriginal(mapName, mapCheckSum) )
											{
												std::cout << lngPack.i18n ( "Text~Multiplayer~MapDL_DownloadRequestInvalid") << std::endl <<
													lngPack.i18n ( "Text~Multiplayer~MapDL_DownloadInvalid", mapName) << std::endl;
											}  else {
												if (mapName != lastRequestedMap)
												{
													lastRequestedMap = mapName;
													sendRequestMap (mapName, playerdata.nr);
//													chatBox->addLine (lngPack.i18n ( "Text~Multiplayer~MapDL_DownloadRequest"));
//													chatBox->addLine (lngPack.i18n ( "Text~Multiplayer~MapDL_Download", mapName));
												}
											}
										}
									
								} else {
									if (!playerdata.ready) {
										playerdata.ready = true;
										sendIdentification ( &playerdata );
									}
								}
							}

//							if ( message->popBool() ) saveGameString = message->popString();
//							else saveGameString = "";

							break;
					}


					default:
						std::cout << "Message type: " <<  message->iType << " ignored!" << std::endl;
						break;
				}
				break;
			default:
				std::cout << "Message class: " <<  message->getClass() << " ignored!" << std::endl;
				break;
			}

			delete message;
		}

	};


int _tmain(int argc, _TCHAR* argv[])
{
//	LoadData(NULL);
	LoadData("c:\\Program Files (x86)\\M.A.X. Reloaded" );
//	cPlayer cp("Myname",  OtherData.colors[cl_red] ,-1);
	// see void cGameDataContainer::runSavedGame( int player )
		SDLNet_Init();
		network = new cTCP;

		network->setPort( 58600);
		network->setIP( "10.0.0.147" );
		if ( network->connect() == -1 ) {
			std::cerr << "Error on connecting, exiting!\n";
			return 1;
		}



		EventHandler = new InitEventHandler();
		// get the number of players


		// see messages
		while (gameState==init) {
//			std::cout << "waiting for server ...." << std::endl;
			SDL_Delay(100);
			((InitEventHandler*)EventHandler)->HandleEvents1();
		}

	return 0;
}

